// This is a generated file, modify: generate/templates/class_content.cc.
#include <nan.h>
#include <string.h>

extern "C" {
#include <git2.h>
}

#include "../include/functions/copy.h"
#include "../include/odb_object.h"
#include "../include/functions/sleep_for_ms.h"

#include "../include/wrapper.h"
#include "node_buffer.h"
#include "../include/oid.h"

#include <iostream>

using namespace std;
using namespace v8;
using namespace node;

GitOdbObject::GitOdbObject(git_odb_object *raw, bool selfFreeing)
{
  this->raw = raw;
  this->selfFreeing = selfFreeing;
}

GitOdbObject::~GitOdbObject()
{
  if (this->selfFreeing) {
    git_odb_object_free(this->raw);
    this->raw = NULL;
  }

  // this will cause an error if you have a non-self-freeing object that also needs
  // to save values. Since the object that will eventually free the object has no
  // way of knowing to free these values.
}

void GitOdbObject::InitializeComponent(Local<v8::Object> target)
{
  Nan::HandleScope scope;

  Local<FunctionTemplate> tpl = Nan::New<FunctionTemplate>(JSNewFunction);

  tpl->InstanceTemplate()->SetInternalFieldCount(1);
  tpl->SetClassName(Nan::New("OdbObject").ToLocalChecked());

  Nan::SetPrototypeMethod(tpl, "data", Data);
  Nan::SetPrototypeMethod(tpl, "dup", Dup);
  Nan::SetPrototypeMethod(tpl, "free", Free);
  Nan::SetPrototypeMethod(tpl, "id", Id);
  Nan::SetPrototypeMethod(tpl, "size", Size);
  Nan::SetPrototypeMethod(tpl, "type", Type);

  Local<Function> _constructor_template = Nan::GetFunction(tpl).ToLocalChecked();
  constructor_template.Reset(_constructor_template);
  Nan::Set(target, Nan::New("OdbObject").ToLocalChecked(), _constructor_template);
}

NAN_METHOD(GitOdbObject::JSNewFunction)
{

  if (info.Length() == 0 || !info[0]->IsExternal()) {
    return Nan::ThrowError("A new GitOdbObject cannot be instantiated.");
  }

  GitOdbObject* object = new GitOdbObject(static_cast<git_odb_object *>(Local<External>::Cast(info[0])->Value()), Nan::To<bool>(info[1]).FromJust());
  object->Wrap(info.This());

  info.GetReturnValue().Set(info.This());
}

Local<v8::Value> GitOdbObject::New(void *raw, bool selfFreeing)
{
  Nan::EscapableHandleScope scope;
  Local<v8::Value> argv[2] = { Nan::New<External>((void *)raw), Nan::New(selfFreeing) };
  return scope.Escape(Nan::NewInstance(Nan::New(GitOdbObject::constructor_template), 2, argv).ToLocalChecked());
}

git_odb_object *GitOdbObject::GetValue()
{
  return this->raw;
}

git_odb_object **GitOdbObject::GetRefValue()
{
  return this->raw == NULL ? NULL : &this->raw;
}

void GitOdbObject::ClearValue()
{
  this->raw = NULL;
}


/*
     * @return Buffer  result    */
NAN_METHOD(GitOdbObject::Data)
{
  Nan::EscapableHandleScope scope;

  const void * result = git_odb_object_data(
                          Nan::ObjectWrap::Unwrap<GitOdbObject>(info.This())->GetValue()
                        );

  // null checks on pointers
  if (!result) {
    return info.GetReturnValue().Set(scope.Escape(Nan::Undefined()));
  }

  Local<v8::Value> to;
// start convert_to_v8 block

  if (result != NULL) {
    // Wrapper result
    to = Wrapper::New((void *)result);
  } else {
    to = Nan::Null();
  }

// end convert_to_v8 block
  return info.GetReturnValue().Set(scope.Escape(to));
}

/*
     * @param OdbObject callback
   */
NAN_METHOD(GitOdbObject::Dup)
{

  if (info.Length() == 0 || !info[0]->IsFunction()) {
    return Nan::ThrowError("Callback is required and must be a Function.");
  }

  DupBaton* baton = new DupBaton;

  baton->error_code = GIT_OK;
  baton->error = NULL;

  baton->source = Nan::ObjectWrap::Unwrap<GitOdbObject>(info.This())->GetValue();

  Nan::Callback *callback = new Nan::Callback(Local<Function>::Cast(info[0]));
  DupWorker *worker = new DupWorker(baton, callback);
  worker->SaveToPersistent("source", info.This());

  Nan::AsyncQueueWorker(worker);
  return;
}

void GitOdbObject::DupWorker::Execute()
{
  int result = git_odb_object_dup(
                 &baton->dest,baton->source    );

  baton->error_code = result;

  if (result != GIT_OK && giterr_last() != NULL) {
    baton->error = git_error_dup(giterr_last());
  }

}

void GitOdbObject::DupWorker::HandleOKCallback()
{
  if (baton->error_code == GIT_OK) {
    Local<v8::Value> to;
// start convert_to_v8 block

    if (baton->dest != NULL) {
      // GitOdbObject baton->dest
      to = GitOdbObject::New((void *)baton->dest, false);
    } else {
      to = Nan::Null();
    }

// end convert_to_v8 block
    Local<v8::Value> result = to;
    Local<v8::Value> argv[2] = {
      Nan::Null(),
      result
    };
    callback->Call(2, argv);
  } else {
    if (baton->error) {
      Local<v8::Value> argv[1] = {
        Nan::Error(baton->error->message)
      };
      callback->Call(1, argv);
      if (baton->error->message)
        free((void *)baton->error->message);
      free((void *)baton->error);
    } else if (baton->error_code < 0) {
      std::queue< Local<v8::Value> > workerArguments;
      bool callbackFired = false;
      while(!workerArguments.empty()) {
        Local<v8::Value> node = workerArguments.front();
        workerArguments.pop();

        if (
          !node->IsObject()
          || node->IsArray()
          || node->IsBooleanObject()
          || node->IsDate()
          || node->IsFunction()
          || node->IsNumberObject()
          || node->IsRegExp()
          || node->IsStringObject()
        ) {
          continue;
        }

        Local<v8::Object> nodeObj = node->ToObject();
        Local<v8::Value> checkValue = nodeObj->GetHiddenValue(Nan::New("NodeGitPromiseError").ToLocalChecked());

        if (!checkValue.IsEmpty() && !checkValue->IsNull() && !checkValue->IsUndefined()) {
          Local<v8::Value> argv[1] = {
            checkValue->ToObject()
          };
          callback->Call(1, argv);
          callbackFired = true;
          break;
        }

        Local<v8::Array> properties = nodeObj->GetPropertyNames();
        for (unsigned int propIndex = 0; propIndex < properties->Length(); ++propIndex) {
          Local<v8::String> propName = properties->Get(propIndex)->ToString();
          Local<v8::Value> nodeToQueue = nodeObj->Get(propName);
          if (!nodeToQueue->IsUndefined()) {
            workerArguments.push(nodeToQueue);
          }
        }
      }

      if (!callbackFired) {
        Local<v8::Object> err = Nan::Error("Method dup has thrown an error.")->ToObject();
        err->Set(Nan::New("errno").ToLocalChecked(), Nan::New(baton->error_code));
        Local<v8::Value> argv[1] = {
          err
        };
        callback->Call(1, argv);
      }
    } else {
      callback->Call(0, NULL);
    }

  }


  delete baton;
}


/*
     */
NAN_METHOD(GitOdbObject::Free)
{
  Nan::EscapableHandleScope scope;

  if (Nan::ObjectWrap::Unwrap<GitOdbObject>(info.This())->GetValue() != NULL) {
    git_odb_object_free(
      Nan::ObjectWrap::Unwrap<GitOdbObject>(info.This())->GetValue()
    );

    Nan::ObjectWrap::Unwrap<GitOdbObject>(info.This())->ClearValue();
  }
  return info.GetReturnValue().Set(scope.Escape(Nan::Undefined()));
}

/*
     * @return Oid  result    */
NAN_METHOD(GitOdbObject::Id)
{
  Nan::EscapableHandleScope scope;

  const git_oid * result = git_odb_object_id(
                             Nan::ObjectWrap::Unwrap<GitOdbObject>(info.This())->GetValue()
                           );

  // null checks on pointers
  if (!result) {
    return info.GetReturnValue().Set(scope.Escape(Nan::Undefined()));
  }

  Local<v8::Value> to;
// start convert_to_v8 block

  if (result != NULL) {
    // GitOid result
    to = GitOid::New((void *)result, false);
  } else {
    to = Nan::Null();
  }

// end convert_to_v8 block
  return info.GetReturnValue().Set(scope.Escape(to));
}

/*
     * @return Number  result    */
NAN_METHOD(GitOdbObject::Size)
{
  Nan::EscapableHandleScope scope;

  size_t result = git_odb_object_size(
                    Nan::ObjectWrap::Unwrap<GitOdbObject>(info.This())->GetValue()
                  );


  Local<v8::Value> to;
// start convert_to_v8 block
  to = Nan::New<Number>( result);
  // end convert_to_v8 block
  return info.GetReturnValue().Set(scope.Escape(to));
}

/*
     * @return Number  result    */
NAN_METHOD(GitOdbObject::Type)
{
  Nan::EscapableHandleScope scope;

  git_otype result = git_odb_object_type(
                       Nan::ObjectWrap::Unwrap<GitOdbObject>(info.This())->GetValue()
                     );


  Local<v8::Value> to;
// start convert_to_v8 block
  to = Nan::New<Number>( result);
  // end convert_to_v8 block
  return info.GetReturnValue().Set(scope.Escape(to));
}
Nan::Persistent<Function> GitOdbObject::constructor_template;
